Loading...
Searching...
No Matches
itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage > Class Template Reference

`#include <itkMultiMetricMultiResolutionImageRegistrationMethod.h>`

## Detailed Description

template<typename TFixedImage, typename TMovingImage>
class itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >

Base class for multi-resolution image registration methods.

This class is an extension of the itk class MultiResolutionImageRegistrationMethod. It allows the use of multiple metrics, which are summed, multiple images, multiple interpolators, and/or multiple image pyramids.

Make sure the following is true:
nrofmetrics >= nrofinterpolators >= nrofmovingpyramids >= nrofmovingimages
nrofmetrics >= nroffixedpyramids >= nroffixedimages
nroffixedregions == nroffixedimages
nrofinterpolators == nrofmetrics OR nrofinterpolators == 1
nroffixedimages == nrofmetrics OR nroffixedimages == 1
etc...

You may also set an interpolator/fixedimage/etc to NULL, if you happen to know that the corresponding metric is not an ImageToImageMetric, but a regularizer for example (which does not need an image.

See also
  ImageRegistrationMethod
  MultiResolutionImageRegistrationMethod

Definition at line 77 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

Inheritance diagram for itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >:
[legend]

## Public Types

using | CombinationMetricPointer = typename CombinationMetricType::Pointer
using | CombinationMetricType = CombinationImageToImageMetric<FixedImageType, MovingImageType>
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer
using | FixedImageConstPointer
using | FixedImagePyramidPointer
using | FixedImagePyramidType
using | FixedImageRegionType
using | FixedImageType
using | InterpolatorPointer
using | InterpolatorType
using | MetricPointer
using | MetricType
using | MovingImageConstPointer
using | MovingImagePyramidPointer
using | MovingImagePyramidType
using | MovingImageType
using | OptimizerPointer = typename OptimizerType::Pointer
using | OptimizerType
using | ParametersType
using | Pointer = SmartPointer<Self>
using | Self = MultiMetricMultiResolutionImageRegistrationMethod
using | Superclass = MultiResolutionImageRegistrationMethod2<TFixedImage, TMovingImage>
using | TransformOutputConstPointer
using | TransformOutputPointer
using | TransformOutputType
using | TransformPointer
using | TransformType
Public Types inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
using | ConstPointer = SmartPointer<const Self>
using | DataObjectPointer = typename DataObject::Pointer
using | FixedImageConstPointer = typename FixedImageType::ConstPointer
using | FixedImagePyramidPointer = typename FixedImagePyramidType::Pointer
using | FixedImagePyramidType = MultiResolutionPyramidImageFilter<FixedImageType, FixedImageType>
using | FixedImageRegionPyramidType = std::vector<FixedImageRegionType>
using | FixedImageRegionType = typename FixedImageType::RegionType
using | FixedImageType = TFixedImage
using | InterpolatorPointer = typename InterpolatorType::Pointer
using | InterpolatorType = typename MetricType::InterpolatorType
using | MetricPointer = typename MetricType::Pointer
using | MetricType = AdvancedImageToImageMetric<FixedImageType, MovingImageType>
using | MovingImageConstPointer = typename MovingImageType::ConstPointer
using | MovingImagePyramidPointer = typename MovingImagePyramidType::Pointer
using | MovingImagePyramidType = MultiResolutionPyramidImageFilter<MovingImageType, MovingImageType>
using | MovingImageType = TMovingImage
using | OptimizerType = SingleValuedNonLinearOptimizer
using | ParametersType = typename MetricType::TransformParametersType
using | Pointer = SmartPointer<Self>
using | Self = MultiResolutionImageRegistrationMethod2
using | Superclass = ProcessObject
using | TransformOutputConstPointer = typename TransformOutputType::ConstPointer
using | TransformOutputPointer = typename TransformOutputType::Pointer
using | TransformOutputType = DataObjectDecorator<TransformType>
using | TransformPointer = typename TransformType::Pointer
using | TransformType = typename MetricType::AdvancedTransformType

## Public Member Functions

| elxOverrideSimpleSetMacro (FixedImage, const FixedImageType *)
| elxOverrideSimpleSetMacro (FixedImagePyramid, FixedImagePyramidType *)
| elxOverrideSimpleSetMacro (FixedImageRegion, const FixedImageRegionType)
| elxOverrideSimpleSetMacro (Interpolator, InterpolatorType *)
| elxOverrideSimpleSetMacro (MovingImage, const MovingImageType *)
| elxOverrideSimpleSetMacro (MovingImagePyramid, MovingImagePyramidType *)
virtual const char * | GetClassName () const
virtual CombinationMetricType * | GetCombinationMetric () const
const FixedImageType * | GetFixedImage () const override
virtual const FixedImageType * | GetFixedImage (unsigned int pos) const
const FixedImagePyramidType * | GetFixedImagePyramid () const override
FixedImagePyramidType * | GetFixedImagePyramid () override
virtual FixedImagePyramidType * | GetFixedImagePyramid (unsigned int pos) const
const FixedImageRegionType & | GetFixedImageRegion () const override
virtual const FixedImageRegionType & | GetFixedImageRegion (unsigned int pos) const
const InterpolatorType * | GetInterpolator () const override
InterpolatorType * | GetInterpolator () override
virtual InterpolatorType * | GetInterpolator (unsigned int pos) const
const ParametersType & | GetLastTransformParameters () const override
const MovingImageType * | GetMovingImage () const override
virtual const MovingImageType * | GetMovingImage (unsigned int pos) const
const MovingImagePyramidType * | GetMovingImagePyramid () const override
MovingImagePyramidType * | GetMovingImagePyramid () override
virtual MovingImagePyramidType * | GetMovingImagePyramid (unsigned int pos) const
ModifiedTimeType | GetMTime () const override
| ITK_DISALLOW_COPY_AND_MOVE (MultiMetricMultiResolutionImageRegistrationMethod)
| itkGetNumberOfMacro (FixedImage)
| itkGetNumberOfMacro (FixedImagePyramid)
| itkGetNumberOfMacro (FixedImageRegion)
| itkGetNumberOfMacro (Interpolator)
| itkGetNumberOfMacro (MovingImage)
| itkGetNumberOfMacro (MovingImagePyramid)
| itkSetNumberOfMacro (FixedImage)
| itkSetNumberOfMacro (FixedImagePyramid)
| itkSetNumberOfMacro (FixedImageRegion)
| itkSetNumberOfMacro (Interpolator)
| itkSetNumberOfMacro (MovingImage)
| itkSetNumberOfMacro (MovingImagePyramid)
virtual void | SetFixedImage (const FixedImageType *_arg, unsigned int pos)
virtual void | SetFixedImagePyramid (FixedImagePyramidType *_arg, unsigned int pos)
virtual void | SetFixedImageRegion (FixedImageRegionType _arg, unsigned int pos)
virtual void | SetInterpolator (InterpolatorType *_arg, unsigned int pos)
void | SetMetric (MetricType *_arg) override
virtual void | SetMovingImage (const MovingImageType *_arg, unsigned int pos)
virtual void | SetMovingImagePyramid (MovingImagePyramidType *_arg, unsigned int pos)
virtual void | StopMultiMetricRegistration ()
Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
virtual unsigned long | GetCurrentLevel () const
virtual const FixedImageType * | GetFixedImage ()
virtual const FixedImageRegionType & | GetFixedImageRegion ()
virtual const ParametersType & | GetInitialTransformParameters ()
virtual const ParametersType & | GetInitialTransformParametersOfNextLevel ()
virtual const ParametersType & | GetLastTransformParameters ()
virtual const MovingImageType * | GetMovingImage ()
ModifiedTimeType | GetMTime () const override
virtual unsigned long | GetNumberOfLevels () const
const TransformOutputType * | GetOutput () const
| ITK_DISALLOW_COPY_AND_MOVE (MultiResolutionImageRegistrationMethod2)
| itkGetModifiableObjectMacro (FixedImagePyramid, FixedImagePyramidType)
| itkGetModifiableObjectMacro (Interpolator, InterpolatorType)
| itkGetModifiableObjectMacro (Metric, MetricType)
| itkGetModifiableObjectMacro (MovingImagePyramid, MovingImagePyramidType)
| itkGetModifiableObjectMacro (Optimizer, OptimizerType)
| itkGetModifiableObjectMacro (Transform, TransformType)
DataObjectPointer | MakeOutput (ProcessObject::DataObjectPointerArraySizeType idx) override
virtual void | SetFixedImage (const FixedImageType *_arg)
virtual void | SetFixedImagePyramid (FixedImagePyramidType *_arg)
virtual void | SetFixedImageRegion (FixedImageRegionType _arg)
virtual void | SetInitialTransformParameters (ParametersType _arg)
virtual void | SetInitialTransformParametersOfNextLevel (ParametersType _arg)
virtual void | SetInterpolator (InterpolatorType *_arg)
virtual void | SetMovingImage (const MovingImageType *_arg)
virtual void | SetMovingImagePyramid (MovingImagePyramidType *_arg)
virtual void | SetNumberOfLevels (unsigned long _arg)
virtual void | SetOptimizer (OptimizerType *_arg)
virtual void | SetTransform (TransformType *_arg)
virtual void | StartRegistration ()
virtual void | StopRegistration ()

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
static Pointer | New ()

## Protected Types

using | FixedImageRegionPyramidType = std::vector<FixedImageRegionType>

## Protected Member Functions

virtual void | CheckOnInitialize ()
virtual void | CheckPyramids ()
void | GenerateData () override
void | Initialize () override
| MultiMetricMultiResolutionImageRegistrationMethod ()
virtual void | PrepareAllPyramids ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~MultiMetricMultiResolutionImageRegistrationMethod () override=default
Protected Member Functions inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
void | GenerateData () override
| MultiResolutionImageRegistrationMethod2 ()
virtual void | PreparePyramids ()
void | PrintSelf (std::ostream &os, Indent indent) const override
virtual void | SetCurrentLevel (unsigned long _arg)
| ~MultiResolutionImageRegistrationMethod2 () override=default

## Protected Attributes

CombinationMetricPointer | m_CombinationMetric {}
std::vector< FixedImagePyramidPointer > | m_FixedImagePyramids {}
std::vector< FixedImageRegionPyramidType > | m_FixedImageRegionPyramids {}
std::vector< FixedImageRegionType > | m_FixedImageRegions {}
std::vector< FixedImageConstPointer > | m_FixedImages {}
std::vector< InterpolatorPointer > | m_Interpolators {}
ParametersType | m_LastTransformParameters {}
std::vector< MovingImagePyramidPointer > | m_MovingImagePyramids {}
std::vector< MovingImageConstPointer > | m_MovingImages {}
FixedImageRegionType | m_NullFixedImageRegion {}
bool | m_Stop {}
Protected Attributes inherited from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >
ParametersType | m_LastTransformParameters {}
bool | m_Stop {}

## Member Typedef Documentation

## CombinationMetricPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::CombinationMetricPointer = typename CombinationMetricType::Pointer

Definition at line 124 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## CombinationMetricType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::CombinationMetricType = CombinationImageToImageMetric<FixedImageType, MovingImageType>

Extra typedefs

Definition at line 123 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## ConstPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::ConstPointer = SmartPointer<const Self>

Definition at line 87 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## DataObjectPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::DataObjectPointer

Smart Pointer type to a DataObject.

Definition at line 160 of file itkMultiResolutionImageRegistrationMethod2.h.

## FixedImageConstPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::FixedImageConstPointer

Definition at line 116 of file itkMultiResolutionImageRegistrationMethod2.h.

## FixedImagePyramidPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::FixedImagePyramidPointer

Definition at line 148 of file itkMultiResolutionImageRegistrationMethod2.h.

## FixedImagePyramidType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::FixedImagePyramidType

Type of the Fixed image multiresolution pyramid.

Definition at line 147 of file itkMultiResolutionImageRegistrationMethod2.h.

## FixedImageRegionPyramidType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::FixedImageRegionPyramidType = std::vector<FixedImageRegionType>

protected

Definition at line 306 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## FixedImageRegionType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::FixedImageRegionType

Definition at line 117 of file itkMultiResolutionImageRegistrationMethod2.h.

## FixedImageType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::FixedImageType

Type of the Fixed image.

Definition at line 115 of file itkMultiResolutionImageRegistrationMethod2.h.

## InterpolatorPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::InterpolatorPointer

Definition at line 141 of file itkMultiResolutionImageRegistrationMethod2.h.

## InterpolatorType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::InterpolatorType

Type of the Interpolator.

Definition at line 140 of file itkMultiResolutionImageRegistrationMethod2.h.

## MetricPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MetricPointer

Definition at line 126 of file itkMultiResolutionImageRegistrationMethod2.h.

## MetricType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MetricType

Type of the metric.

Definition at line 125 of file itkMultiResolutionImageRegistrationMethod2.h.

## MovingImageConstPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MovingImageConstPointer

Definition at line 122 of file itkMultiResolutionImageRegistrationMethod2.h.

## MovingImagePyramidPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MovingImagePyramidPointer

Definition at line 152 of file itkMultiResolutionImageRegistrationMethod2.h.

## MovingImagePyramidType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MovingImagePyramidType

Type of the moving image multiresolution pyramid.

Definition at line 151 of file itkMultiResolutionImageRegistrationMethod2.h.

## MovingImageType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::MovingImageType

Type of the Moving image.

Definition at line 121 of file itkMultiResolutionImageRegistrationMethod2.h.

## OptimizerPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::OptimizerPointer = typename OptimizerType::Pointer

Definition at line 109 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## OptimizerType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::OptimizerType

Type of the optimizer.

Definition at line 144 of file itkMultiResolutionImageRegistrationMethod2.h.

## ParametersType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::ParametersType

Type of the Transformation parameters This is the same type used to represent the search space of the optimization algorithm.

Definition at line 157 of file itkMultiResolutionImageRegistrationMethod2.h.

## Pointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::Pointer = SmartPointer<Self>

Definition at line 86 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## Self

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::Self = MultiMetricMultiResolutionImageRegistrationMethod

Standard class typedefs.

Definition at line 84 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## Superclass

template<typename TFixedImage, typename TMovingImage>

using itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::Superclass = MultiResolutionImageRegistrationMethod2<TFixedImage, TMovingImage>

Definition at line 85 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## TransformOutputConstPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::TransformOutputConstPointer

Definition at line 137 of file itkMultiResolutionImageRegistrationMethod2.h.

## TransformOutputPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::TransformOutputPointer

Definition at line 136 of file itkMultiResolutionImageRegistrationMethod2.h.

## TransformOutputType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::TransformOutputType

Type for the output: Using Decorator pattern for enabling the Transform to be passed in the data pipeline.

Definition at line 135 of file itkMultiResolutionImageRegistrationMethod2.h.

## TransformPointer

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::TransformPointer

Definition at line 130 of file itkMultiResolutionImageRegistrationMethod2.h.

## TransformType

template<typename TFixedImage, typename TMovingImage>

using itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >::TransformType

Type of the Transform .

Definition at line 129 of file itkMultiResolutionImageRegistrationMethod2.h.

## Constructor & Destructor Documentation

## MultiMetricMultiResolutionImageRegistrationMethod()

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::MultiMetricMultiResolutionImageRegistrationMethod | ( |  | ) |

protected

## ~MultiMetricMultiResolutionImageRegistrationMethod()

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::~MultiMetricMultiResolutionImageRegistrationMethod | ( |  | ) |

override protected default

## Member Function Documentation

## CheckOnInitialize()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::CheckOnInitialize | ( |  | ) |

protected virtual

Function called by Initialize, which checks if the user input is ok. Called by Initialize().

## CheckPyramids()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::CheckPyramids | ( |  | ) |

protected virtual

Function called by PrepareAllPyramids, which checks if the user input regarding the image pyramids is ok.

## elxOverrideSimpleSetMacro() [1/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | FixedImage | ,
|  | const FixedImageType * | )

## elxOverrideSimpleSetMacro() [2/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | FixedImagePyramid | ,
|  | FixedImagePyramidType * | )

## elxOverrideSimpleSetMacro() [3/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | FixedImageRegion | ,
|  | const FixedImageRegionType | )

## elxOverrideSimpleSetMacro() [4/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | Interpolator | ,
|  | InterpolatorType * | )

## elxOverrideSimpleSetMacro() [5/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | MovingImage | ,
|  | const MovingImageType * | )

## elxOverrideSimpleSetMacro() [6/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::elxOverrideSimpleSetMacro | ( | MovingImagePyramid | ,
|  | MovingImagePyramidType * | )

## GenerateData()

template<typename TFixedImage, typename TMovingImage>

void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GenerateData | ( |  | ) |

override protected

Method invoked by the pipeline in order to trigger the computation of the registration.

## GetClassName()

template<typename TFixedImage, typename TMovingImage>

virtual const char * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >.

Reimplemented in elastix::MultiMetricMultiResolutionRegistration< TElastix >.

## GetCombinationMetric()

template<typename TFixedImage, typename TMovingImage>

virtual CombinationMetricType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetCombinationMetric | ( |  | ) | const

inline virtual

Get the metric as a pointer to a combination metric type. Use this method to setup the combination metric (set weights, nrofmetrics, submetrics, etc.

Definition at line 151 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetFixedImage() [1/2]

template<typename TFixedImage, typename TMovingImage>

const FixedImageType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImage | ( |  | ) | const

inline override

Definition at line 172 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetFixedImage() [2/2]

template<typename TFixedImage, typename TMovingImage>

virtual const FixedImageType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImage | ( | unsigned int | pos | ) | const

virtual

## GetFixedImagePyramid() [1/3]

template<typename TFixedImage, typename TMovingImage>

const FixedImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImagePyramid | ( |  | ) | const

inline override

Definition at line 251 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetFixedImagePyramid() [2/3]

template<typename TFixedImage, typename TMovingImage>

FixedImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImagePyramid | ( |  | ) |

inline override

Definition at line 245 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetFixedImagePyramid() [3/3]

template<typename TFixedImage, typename TMovingImage>

virtual FixedImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImagePyramid | ( | unsigned int | pos | ) | const

virtual

## GetFixedImageRegion() [1/2]

template<typename TFixedImage, typename TMovingImage>

const FixedImageRegionType & itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImageRegion | ( |  | ) | const

inline override

Definition at line 206 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetFixedImageRegion() [2/2]

template<typename TFixedImage, typename TMovingImage>

virtual const FixedImageRegionType & itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetFixedImageRegion | ( | unsigned int | pos | ) | const

virtual

## GetInterpolator() [1/3]

template<typename TFixedImage, typename TMovingImage>

const InterpolatorType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetInterpolator | ( |  | ) | const

inline override

Definition at line 228 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetInterpolator() [2/3]

template<typename TFixedImage, typename TMovingImage>

InterpolatorType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetInterpolator | ( |  | ) |

inline override

Definition at line 222 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetInterpolator() [3/3]

template<typename TFixedImage, typename TMovingImage>

virtual InterpolatorType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetInterpolator | ( | unsigned int | pos | ) | const

virtual

## GetLastTransformParameters()

template<typename TFixedImage, typename TMovingImage>

const ParametersType & itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetLastTransformParameters | ( |  | ) | const

inline override

Get the last transformation parameters visited by the optimizer. Return the member variable declared in this class, and not that of the superclass (which is declared private).

Definition at line 294 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetMovingImage() [1/2]

template<typename TFixedImage, typename TMovingImage>

const MovingImageType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMovingImage | ( |  | ) | const

inline override

Definition at line 190 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetMovingImage() [2/2]

template<typename TFixedImage, typename TMovingImage>

virtual const MovingImageType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMovingImage | ( | unsigned int | pos | ) | const

virtual

## GetMovingImagePyramid() [1/3]

template<typename TFixedImage, typename TMovingImage>

const MovingImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMovingImagePyramid | ( |  | ) | const

inline override

Definition at line 274 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetMovingImagePyramid() [2/3]

template<typename TFixedImage, typename TMovingImage>

MovingImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMovingImagePyramid | ( |  | ) |

inline override

Definition at line 268 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## GetMovingImagePyramid() [3/3]

template<typename TFixedImage, typename TMovingImage>

virtual MovingImagePyramidType * itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMovingImagePyramid | ( | unsigned int | pos | ) | const

virtual

## GetMTime()

template<typename TFixedImage, typename TMovingImage>

ModifiedTimeType itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::GetMTime | ( |  | ) | const

override

Method to return the latest modified time of this object or any of its cached ivars.

## Initialize()

template<typename TFixedImage, typename TMovingImage>

void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::Initialize | ( |  | ) |

override protected virtual

Initialize by setting the interconnects between the components. This method is executed at every level of the pyramid with the values corresponding to this resolution.

Reimplemented from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage > |  | ) |

## itkGetNumberOfMacro() [1/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | FixedImage |  | ) |

## itkGetNumberOfMacro() [2/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | FixedImagePyramid |  | ) |

## itkGetNumberOfMacro() [3/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | FixedImageRegion |  | ) |

## itkGetNumberOfMacro() [4/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | Interpolator |  | ) |

## itkGetNumberOfMacro() [5/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | MovingImage |  | ) |

## itkGetNumberOfMacro() [6/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkGetNumberOfMacro | ( | MovingImagePyramid |  | ) |

## itkSetNumberOfMacro() [1/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | FixedImage |  | ) |

## itkSetNumberOfMacro() [2/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | FixedImagePyramid |  | ) |

## itkSetNumberOfMacro() [3/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | FixedImageRegion |  | ) |

## itkSetNumberOfMacro() [4/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | Interpolator |  | ) |

## itkSetNumberOfMacro() [5/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | MovingImage |  | ) |

## itkSetNumberOfMacro() [6/6]

template<typename TFixedImage, typename TMovingImage>

itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::itkSetNumberOfMacro | ( | MovingImagePyramid |  | ) |

## New()

template<typename TFixedImage, typename TMovingImage>

Pointer itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrepareAllPyramids()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::PrepareAllPyramids | ( |  | ) |

protected virtual

Compute the size of the fixed region for each level of the pyramid. Actually we would like to override PreparePyramids, but this function is not virtual...

## PrintSelf()

template<typename TFixedImage, typename TMovingImage>

void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

## SetFixedImage()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetFixedImage | ( | const FixedImageType * | _arg,
|  | unsigned int | pos )

virtual

The following methods all have a similar pattern. The SetFixedImage() just calls SetFixedImage(0). SetFixedImage(0) also calls the Superclass::SetFixedImage(). This is defined by the elxOverrideSimpleSetMacro. GetFixedImage() just returns GetFixedImage(0) == Superclass::m_FixedImage. Set/Get the fixed image.

## SetFixedImagePyramid()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetFixedImagePyramid | ( | FixedImagePyramidType * | _arg,
|  | unsigned int | pos )

virtual

Set/Get the FixedImagePyramid.

## SetFixedImageRegion()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetFixedImageRegion | ( | FixedImageRegionType | _arg,
|  | unsigned int | pos )

virtual

Set/Get the fixed image region.

## SetInterpolator()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetInterpolator | ( | InterpolatorType * | _arg,
|  | unsigned int | pos )

virtual

Set/Get the interpolator.

## SetMetric()

template<typename TFixedImage, typename TMovingImage>

void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetMetric | ( | MetricType * | _arg | ) |

override virtual

Set the Metric. Reimplement this method to check if the metric is a combination metric. GetMetric returns the combination metric. By default, a combination metric is already set on constructing this class.

Reimplemented from itk::MultiResolutionImageRegistrationMethod2< TFixedImage, TMovingImage >.

## SetMovingImage()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetMovingImage | ( | const MovingImageType * | _arg,
|  | unsigned int | pos )

virtual

Set/Get the moving image.

## SetMovingImagePyramid()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::SetMovingImagePyramid | ( | MovingImagePyramidType * | _arg,
|  | unsigned int | pos )

virtual

Set/Get the MovingImagePyramid.

## StopMultiMetricRegistration()

template<typename TFixedImage, typename TMovingImage>

virtual void itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::StopMultiMetricRegistration | ( |  | ) |

inline virtual

Unfortunately the StopRegistration method is not virtual and the m_Stop member is private in the superclass. That's why we provide the following function to interrupt registration.

Definition at line 131 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## Field Documentation

## m_CombinationMetric

template<typename TFixedImage, typename TMovingImage>

CombinationMetricPointer itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_CombinationMetric {}

protected

A shortcut to m_Metric of type CombinationMetricPointer.

Definition at line 345 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_FixedImagePyramids

template<typename TFixedImage, typename TMovingImage>

std::vector<FixedImagePyramidPointer> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_FixedImagePyramids {}

protected

Definition at line 351 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_FixedImageRegionPyramids

template<typename TFixedImage, typename TMovingImage>

std::vector<FixedImageRegionPyramidType> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_FixedImageRegionPyramids {}

protected

This vector is filled by the PrepareAllPyramids function.

Definition at line 356 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_FixedImageRegions

template<typename TFixedImage, typename TMovingImage>

std::vector<FixedImageRegionType> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_FixedImageRegions {}

protected

Definition at line 350 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_FixedImages

template<typename TFixedImage, typename TMovingImage>

std::vector<FixedImageConstPointer> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_FixedImages {}

protected

Containers for the pointers supplied by the user.

Definition at line 348 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_Interpolators

template<typename TFixedImage, typename TMovingImage>

std::vector<InterpolatorPointer> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_Interpolators {}

protected

Definition at line 353 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_LastTransformParameters

template<typename TFixedImage, typename TMovingImage>

ParametersType itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_LastTransformParameters {}

protected

Definition at line 342 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_MovingImagePyramids

template<typename TFixedImage, typename TMovingImage>

std::vector<MovingImagePyramidPointer> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_MovingImagePyramids {}

protected

Definition at line 352 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_MovingImages

template<typename TFixedImage, typename TMovingImage>

std::vector<MovingImageConstPointer> itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_MovingImages {}

protected

Definition at line 349 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_NullFixedImageRegion

template<typename TFixedImage, typename TMovingImage>

FixedImageRegionType itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_NullFixedImageRegion {}

protected

Dummy image region.

Definition at line 359 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

## m_Stop

template<typename TFixedImage, typename TMovingImage>

bool itk::MultiMetricMultiResolutionImageRegistrationMethod< TFixedImage, TMovingImage >::m_Stop {}

protected

Variables already defined in the superclass, but as private...

Definition at line 341 of file itkMultiMetricMultiResolutionImageRegistrationMethod.h.

Generated on 1768596610 for elastix by 1.15.0 |